local name, addon = ...
local modulname = 'bank'
local events = {}
local modul = {}
local playerID
local BankIsOpen = false
local function scanAllBankBags(delayed)
	if(not BankIsOpen) then return end
	if(not addon['funcSync'](scanAllBankBags,delayed)) then return end
	addon['wipeResults']()
	local playerID = addon.getPID()
	if(playerID) then
		modul['db'][playerID] = modul['db'][playerID] or {}
		for bag=5,GetNumBankSlots()+4 do
			modul['db'][playerID][bag] = addon['scanBag'](bag) -- loop all bought bankbags
		end
		modul['db'][playerID][-1] = addon['scanBag'](-1) -- Main bankbag
		modul['db'][playerID][-3] = addon['scanBag'](-3) -- Main reagentbag
		for k,v in pairs(modul['db'][playerID]) do
			if(not(k==-1) and not(k==-3) and not(k>4 and k<=GetNumBankSlots()+4)) then
				modul['db'][playerID][k] = nil -- prevent bogus bankbags
			end
		end
	end
end
local function bagLoop(id,res)
	local cName = modulname.."Count"
	local dName = cName
	for k,v in pairs(modul['db']) do
		local units = addon['getUnits']()
		if(units[k]) then
			if(units[k]['faction']==units[playerID]['faction']) then
				local unitname = units[k]['name']
				for bag,list in pairs(v) do
					if(bag == -3) then
						dName = 'reagentCount'
					else
						dName = cName
					end
					for a,b in pairs(list) do
						if(a == id) then
							res[unitname] = res[unitname] or {
								[dName] = 0
							}
							res[unitname][dName] = res[unitname][dName] or 0
							res[unitname][dName] = res[unitname][dName] + b['count']
						end
					end
				end
			end
		end
	end
	return res
end
function modul.Search(id,res)
	if(not playerID) then
		playerID = addon.getPID()
		if(playerID) then
			modul['db'][playerID] = modul['db'][playerID] or {}
		end
	end
	return playerID and bagLoop(id,res) or res
end
function modul.Output(input,sum,b)
	local desc = modulname..'Count'
	if(b[desc] and b[desc]>0) then
		input[#input+1] = format("Bank %s",b[desc])
		sum = sum + b[desc]					
	end
	desc = 'reagentCount'
	if(b[desc] and b[desc]>0) then
		input[#input+1] = format("Reagents %s",b[desc])
		sum = sum + b[desc]					
	end
	return input,sum
end
function events:BANKFRAME_OPENED(event,...)
	BankIsOpen = true
	scanAllBankBags(nil)
end
function events:BANKFRAME_CLOSED(event,...)
	BankIsOpen = false
end
function events:PLAYERBANKBAGSLOTS_CHANGED(event,...)
	scanAllBankBags(nil)
end
function events:PLAYERBANKSLOTS_CHANGED(event,...)
	scanAllBankBags(nil)
end
function events:PLAYERREAGENTBANKSLOTS_CHANGED(event,...)
	scanAllBankBags(nil)
end
function events:ITEM_UNLOCKED(event,...)
	scanAllBankBags(nil)
end
local function OnEvent(self,event,...)
	if(not playerID) then
		playerID = addon.getPID()
		if(playerID) then
			modul['db'][playerID] = modul['db'][playerID] or {}
		end
	end
	if(playerID and type(events[event])=='function') then
		events[event](self, event, ...)
	end
end
function modul:Enable()
	local list = {}
	for event,func in pairs(events) do
		list[#list+1] = event
	end
	modul.frame = addon['RegisterFunc'](list,"OnEvent",OnEvent)
end
function modul:Disable()
	for event,func in pairs(events) do
		self.frame:UnregisterEvent(event)
	end
end
addon['inits'][#addon['inits']+1] = function()
	modul.db = addon['RegisterModul'](modul, modulname)
	modul:Enable()
end