local name, addon = ...
local modulname = 'guildbank'
local events = {}
local modul = {}
local guildID
local GuildBankIsOpen = false
local function gbagLoop(id)
	local res = {}
	local dName = modulname.."Count"
	for k,v in pairs(modul['db']) do
		local guilds = addon['getGuilds']()
		if(guilds[k]) then
			if(guildID and guilds[k]['faction']==guilds[guildID]['faction'] or not guildID) then
				local guildname = guilds[k]['name']
				for bag,list in pairs(v) do
					for a,b in pairs(list) do
						if(a == id) then
							res[guildname] = res[guildname] or {
								[dName] = 0
							}
							res[guildname][dName] = res[guildname][dName] or 0
							res[guildname][dName] = res[guildname][dName] + b['count']
						end
					end
				end
			end
		end
	end
	return res
end
function modul.Search2(id,res,mode)
	if(not guildID) then
		guildID = addon.getGID()
		if(guildID) then
			modul['db'][guildID] = modul['db'][guildID] or {}
		end
	end
	res = res or {}
	for guildname, b in pairs(gbagLoop(id)) do
		if(mode) then
			res[#res+1] = format(" %s: %s",addon['colorize'](guildname,"00ffff"),addon['colorize'](b[modulname..'Count'],"ffffff"))
		else
			res[#res+1] = format("%s %s: %s",addon['getIcon'](id),guildname,addon['colorize'](b[modulname..'Count'],"ffffff"))
		end
	end
	return res
end
local function scanGuildBank(tab)
	local itemlist = {}
	local empty = true
	for slot = 1,14*7 do
		local texturePath, itemCount, locked, isFiltered = GetGuildBankItemInfo(tab,slot)
		if(itemCount>0) then
			emtpy = false
			local itemLink = GetGuildBankItemLink(tab,slot)
			if(itemLink) then
				local id = addon['getItemId'](itemLink)
				if(id) then
					empty = false
					if(addon['getResult'](id)) then
						addon['setResult'](id,nil)
					end
					itemlist[id] = itemlist[id] or {}
					itemlist[id]['count'] = itemlist[id]['count'] or 0
					itemlist[id]['count'] = itemlist[id]['count'] + itemCount
					addon['getName'](id)
				end
			end
		end
	end
	return empty and nil or itemlist
end
function events:GUILDBANKBAGSLOTS_CHANGED(event,...)
	if(not addon.checkGID() or not GuildBankIsOpen) then return end
	local tab = GetCurrentGuildBankTab()
	if(tab>0) then
		local list = scanGuildBank(tab)
		if(list and guildID) then
			modul['db'][guildID][tab] = list
		end
	end
end
function events:GUILDBANKFRAME_CLOSED(event,...)
	GuildBankIsOpen = false
end
function events:GUILDBANKFRAME_OPENED(event,...)
	GuildBankIsOpen = true
	addon['wipeResults']()
end
local function OnEvent(self,event,...)
	if(not guildID) then
		guildID = addon.getGID()
		if(guildID) then
			modul['db'][guildID] = modul['db'][guildID] or {}
		end
	end
	if(guildID and type(events[event])=='function') then
		events[event](self, event, ...)
	end
end
function modul:Enable()
	local list = {}
	for event,func in pairs(events) do
		list[#list+1] = event
	end
	modul.frame = addon['RegisterFunc'](list,"OnEvent",OnEvent)
end
function modul:Disable()
	for event,func in pairs(events) do
		self.frame:UnregisterEvent(event)
	end
end
addon['inits'][#addon['inits']+1] = function()
	modul.db = addon['RegisterModul'](modul, modulname)
	modul:Enable()
end