local name, addon = ...
local modulname = 'void'
local events = {}
local modul = {}
local playerID
local voidOpen
local function scanVoid()
	if(not voidOpen) then return end
	local itemlist = {}
	local empty = true
	for tab=1,2 do
		for slot=1,80 do
			local id, icon = GetVoidItemInfo(tab, slot)
			if(id) then
				id = tonumber(id)
				empty = false
				if(addon['getResult'](id)) then
					addon['setResult'](id,nil)
				end
				itemlist[id] = itemlist[id] or {}
				itemlist[id]['count'] = (itemlist[id]['count'] or 0) + 1
				addon['getName'](id)
				addon['setIcon'](id, icon)				
			end
		end
	end
	return empty and nil or itemlist
end
local function bagLoop(id,res)
	local dName = modulname.."Count"
	for k,v in pairs(modul['db']) do
		local units = addon['getUnits']()
		if(units[k]) then
			if(units[k]['faction']==units[playerID]['faction']) then
				local unitname = units[k]['name']
				for bag,list in pairs(v) do
					for a,b in pairs(list) do
						if(a == id) then
							res[unitname] = res[unitname] or {
								[dName] = 0
							}
							res[unitname][dName] = (res[unitname][dName] or 0) + b['count']
						end
					end
				end
			end
		end
	end
	return res
end
function modul.Search(id,res)
	if(not playerID) then
		playerID = addon.getPID()
		if(playerID) then
			modul['db'][playerID] = modul['db'][playerID] or {}
		end
	end
	return playerID and bagLoop(id,res) or res
end
function modul.Output(input,sum,b)
	local desc = modulname..'Count'
	if(b[desc] and b[desc]>0) then
		input[#input+1] = format("Void %s",b[desc])
		sum = sum + b[desc]					
	end
	return input,sum
end
function events:VOID_STORAGE_CLOSE(event,...)
	voidOpen = false
end
function events:VOID_STORAGE_OPEN(event,...)
	voidOpen = true
	modul['db'][playerID][0] = scanVoid()
end
function events:VOID_STORAGE_CONTENTS_UPDATE(event,...)
	modul['db'][playerID][0] = scanVoid()	
end
function events:VOID_STORAGE_DEPOSIT_UPDATE(event,...)
	modul['db'][playerID][0] = scanVoid()	
end
function events:ITEM_UNLOCKED(event,...)
	modul['db'][playerID][0] = scanVoid()	
end
function events:VOID_TRANSFER_DONE(event,...)
	modul['db'][playerID][0] = scanVoid()	
end
local function OnEvent(self,event,...)
	if(not playerID) then
		playerID = addon.getPID()
		if(playerID) then
			modul['db'][playerID] = modul['db'][playerID] or {}
		end
	end
	if(playerID and type(events[event])=='function') then
		events[event](self, event, ...)
	end
end
function modul:Enable()
	local list = {}
	for event,func in pairs(events) do
		list[#list+1] = event
	end
	modul.frame = addon['RegisterFunc'](list,"OnEvent",OnEvent)
end
function modul:Disable()
	for event,func in pairs(events) do
		self.frame:UnregisterEvent(event)
	end
end
addon['inits'][#addon['inits']+1] = function()
	modul.db = addon['RegisterModul'](modul, modulname)
	modul:Enable()
end